#ifndef __CLF_GEOMETRY__
#define __CLF_GEOMETRY__

#include <vector>

class clf_point2D{
public:
    float x;
    float y;
    clf_point2D():x(0.f), y(0.f){
    }
    clf_point2D(float _x, float _y):x(_x), y(_y){
    }
    clf_point2D(int _x, int _y):x((float)_x), y((float)_y){
    }
    ~clf_point2D(){
    }
};

class clf_rect2D{
public:
    float left;
    float top;
    float right;
    float bottom;
    clf_rect2D() : left(0.f),top(0.f),right(0.f),bottom(0.f) {
    }
    clf_rect2D(float l, float t, float r, float b) : left(l),top(t),right(r),bottom(b) {
    }
    clf_rect2D(clf_rect2D& p) : left(p.left),top(p.top),right(p.right),bottom(p.bottom) {
    }
    ~clf_rect2D(){
    }
};

class clf_polygon2D : public std::vector< clf_point2D>{
public:
	clf_rect2D bounds;
	clf_polygon2D(){
	}
    ~clf_polygon2D(){
	}

	void add_point(const clf_point2D& pt){
		if (size() == 0)
		{
			bounds = clf_rect2D(pt.x, pt.y, pt.x, pt.y);
		}
		else
		{
			if (bounds.left > pt.x) bounds.left = pt.x;
			if (bounds.right < pt.x) bounds.right = pt.x;
			if (bounds.top < pt.y) bounds.top = pt.y;
			if (bounds.bottom > pt.y) bounds.bottom = pt.y;
		}
		push_back(clf_point2D(pt.x, pt.y));
	}
};

bool intersect(const clf_point2D& p1, const clf_point2D& p2, const clf_point2D& p3, const clf_point2D& p4, clf_point2D* p0);
bool point_in_polygon(clf_polygon2D& poly, clf_point2D pt);
bool polygons_collide(clf_polygon2D& poly1, clf_polygon2D& poly2);
void rotate2D(float cx, float cy, float *x, float *y, float angle);

#endif // __CLF_GEOMETRY__
