#ifndef __CLF_OBJECT__
#define __CLF_OBJECT__

#include <list>
#include "clf_geometry.h"

class clf_object
{
	clf_rect2D m_pos;
	float m_orientation;
protected:
	clf_polygon2D outline;
public:
	clf_object(): m_orientation(0.f){
	}
	virtual ~clf_object(){
	}

	virtual void render_object(){
	}
	virtual void frame_move(float fElapsed){
	}
	virtual void user_input(bool kdn[]){
	}
	virtual void stop(){
	}
	friend class clf_object_manager;
};

class clf_object_manager : public std::list<clf_object*>{
public:
	clf_object_manager();
	~clf_object_manager();
	void add_object(clf_object* pob);
	void remove_object(clf_object* pob);
	void frame_render();
	void frame_move(float fElapsed);
	void user_input(bool kdn[]);
};

class clf_car : public clf_object{
	float speed;					// speed of car
	float heading;				// direction of car
	float position[3];			// car position vector (x,y,z)
	float steering_angle;        // whatever the name implies
	float wheelbase;
	float acceleration;
	bool moving;
public:
	clf_car();
	virtual ~clf_car();
	virtual void render_object();
	virtual void frame_move(float fElapsed);
	virtual void user_input(bool kdn[]);
	virtual void stop();
};

class clf_building : public clf_object {
public:
	clf_building();
	virtual ~clf_building();
	virtual void render_object();
	void setup(clf_polygon2D& _ol);
};

#endif // __CLF_OBJECT__
